"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransformResponseInterceptor = void 0;
const nestjs_rabbitmq_1 = require("@golevelup/nestjs-rabbitmq");
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const operators_1 = require("rxjs/operators");
let TransformResponseInterceptor = class TransformResponseInterceptor {
    constructor(adapterHost) {
        this.httpAdapter = adapterHost.httpAdapter;
    }
    intercept(context, next) {
        if ((0, nestjs_rabbitmq_1.isRabbitContext)(context))
            return next.handle();
        return next.handle().pipe((0, operators_1.map)((responseController) => {
            if (typeof responseController == 'undefined')
                return null;
            return this.interceptResponse(responseController, context);
        }));
    }
    interceptResponse(responseController, context) {
        const ctx = context.switchToHttp();
        const response = ctx.getResponse();
        const { headers, status, body } = responseController;
        const headersName = Object.getOwnPropertyNames(headers);
        headersName.forEach((header) => {
            const headerValue = headers[header];
            this.httpAdapter.setHeader(response, header, headerValue);
        });
        this.httpAdapter.status(response, status);
        return body;
    }
};
exports.TransformResponseInterceptor = TransformResponseInterceptor;
exports.TransformResponseInterceptor = TransformResponseInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.HttpAdapterHost])
], TransformResponseInterceptor);
